﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using TFC.NET.Entities;
using TFC.NET.Business;
using System.IO;
using System.Reflection;
using TFC.NET.Master;
using System.Text;

namespace TFC.NET
{
    public partial class Albums : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {

            if (!Page.IsPostBack)
            {

                try
                {
                    User userTo = null;
                    User userFrom = null;
                    Decimal userid;
                    Private privateFunctions = new Private();

                    privateFunctions.isLoggedSession(ref userFrom);

                    if (!string.IsNullOrEmpty(Request["userid"]) && Decimal.TryParse(Request["userid"], out userid))
                    {
                        userTo = new User()
                        {
                            UserID = userid
                        };

                        if (!GlobalBS.GetUser(ref userTo))
                        {
                            throw new WrongDataException("No se han podido recuperar datos para el usuario solicitado");
                        }

                    }
                    else
                    {
                        userTo = userFrom;

                    }

                    List<Album> albumList = new List<Album>();
                    if (GlobalBS.GetAlbums(userFrom, userTo, ref albumList))
                    {
                        if (albumList.Count > 0)
                        {
                            rptAlbum.DataSource = albumList;
                            pnlNoAlbums.Visible = false;
                        }
                        else
                        {
                            rptAlbum.DataSource = null;
                            pnlNoAlbums.Visible = true;
                        }
                        rptAlbum.DataBind();

                        
                    }

                    pnlpictures.Visible = false;
                }
                catch (WrongDataException ex)
                {
                    //Script register to show exception info
                    ScriptManager.RegisterStartupScript(this, this.GetType(), "showMsg", string.Format(@"jsError('{0}');", ex.Message), true);
                    return;
                }
                catch (Exception ex)
                {
                    //Script register to show exception info
                    ScriptManager.RegisterStartupScript(this, this.GetType(), "showMsg", @"jsError('Lo sentimos pero ha ocurrido un error inexperado');", true);
                    Utilities.LogException(Path.GetFileName(Request.Path),
                                MethodInfo.GetCurrentMethod().Name,
                                ex);
                    return;
                }
            }
            else
            {
                string eventArgs = Request["__EVENTARGUMENT"];
                if (eventArgs.StartsWith("LoadAlbum"))
                {
                    Decimal albumid;
                    if (Decimal.TryParse(eventArgs.Split(';')[1], out albumid))
                    {
                        TFC.NET.Entities.Album album = new TFC.NET.Entities.Album()
                        {
                            AlbumID = albumid
                        };

                        List<Picture> pictureList = new List<Picture>();

                        if (GlobalBS.GetPicturesFromAlbum(ref album, ref pictureList))
                        {
                            rptPictures.DataSource = pictureList;
                            rptPictures.DataBind();
                            pnlpictures.Visible = true;
                            ScriptManager.RegisterStartupScript(this, this.GetType(), "showMsg", @"ReloadJObjects();", true);
                        }

                    }
                }
            }

        }

        protected string ShowAlbumImage(Picture p, int i)
        {
            StringBuilder str = new StringBuilder();
            str.Append("<div id=\"pic-{0}\" class=\"pic\" style=\"top:{1}px;left:{2}px;background:url(AjaxHandler.ashx?fn=ResizeRatio&w=100&h=100&src=/userData/{3}) no-repeat 50% 50%; -moz-transform:rotate({4}deg); -webkit-transform:rotate({4}deg);\"> ");
            str.Append("<a title=\"{5}\" class=\"fancybox-thumb\" rel=\"album1\" href=\"/userData/{3}\">");
            str.Append("</a></div>");

            int[] properties = p.GetProperties();

            return string.Format(str.ToString(),i, properties[0],properties[1],p.PicPath,properties[2],p.PicDesc);
        }

        protected void btnAlbum_Click(object sender, EventArgs e)
        {
            User user = null;
            Decimal userid;
            if (!string.IsNullOrEmpty(Request["userid"]) && Decimal.TryParse(Request["userid"], out userid))
            {
                user = new User()
                {
                    UserID = userid
                };

                if (!GlobalBS.GetUser(ref user))
                {
                    throw new WrongDataException("No se han podido recuperar datos para el usuario solicitado");
                }

            }
            else
            {
                Private privateFunctions = new Private();

                privateFunctions.isLoggedSession(ref user);

            }
        }
    }
}