﻿<%@ Control Language="C#" AutoEventWireup="true" CodeBehind="TopBar.ascx.cs" Inherits="TFC.NET.Control.TopBar" %>
<%@ Register Assembly="AjaxControlToolkit" Namespace="AjaxControlToolkit" TagPrefix="ajaxToolkit" %>

<ajaxToolkit:AutoCompleteExtender ID="autoComplete" runat="server"
  EnableCaching="true"
  BehaviorID="AutoCompleteEx"
  MinimumPrefixLength="2"
  TargetControlID="txtSearch"
  ServicePath="AutoComplete.asmx"
  ServiceMethod="GetMyUsersLinkedLike" 
  CompletionInterval="1000"  
  CompletionSetCount="20"
  CompletionListCssClass="autocomplete_completionListElement"
  CompletionListItemCssClass="autocomplete_listItem"
  CompletionListHighlightedItemCssClass="autocomplete_highlightedListItem"
  DelimiterCharacters=";, :"
  ShowOnlyCurrentWordInCompletionListItem="true">
      <Animations>
          <OnShow>
              <Sequence>
              <%-- Make the completion list transparent and then show it --%>
              <OpacityAction Opacity="0" />
              <HideAction Visible="true" />

              <%--Cache the original size of the completion list the first time
                the animation is played and then set it to zero --%>
              <ScriptAction Script="// Cache the size and setup the initial size
                                            var behavior = $find('AutoCompleteEx');
                                            if (!behavior._height) {
                                                var target = behavior.get_completionList();
                                                behavior._height = target.offsetHeight - 2;
                                                target.style.height = '0px';
                                            }" />
              <%-- Expand from 0px to the appropriate size while fading in --%>
              <Parallel Duration=".4">
                  <FadeIn />
                  <Length PropertyKey="height" StartValue="0" 
	                EndValueScript="$find('AutoCompleteEx')._height" />
              </Parallel>
              </Sequence>
          </OnShow>
          <OnHide>
              <%-- Collapse down to 0px and fade out --%>
              <Parallel Duration=".4">
              <FadeOut />
              <Length PropertyKey="height" StartValueScript=
	            "$find('AutoCompleteEx')._height" EndValue="0" />
              </Parallel>
          </OnHide>
      </Animations>
  </ajaxToolkit:AutoCompleteExtender>

<div class="topbar shadow fixed_always">
	<div class="userconf">
		<div class="conficon"></div>
        <a href="Home.aspx"><%=UserName %></a>
	</div>
	<div class="confmenu hidden">
		<div class="toparrow"></div>
		<ul>
			<li><a href="Settings.aspx">Perfil y privacidad</a></li>
			<li><a href="UploadImage.aspx">Gesti&oacute;n de im&aacute;genes</a></li>
			<li><a href="CreateSchedule.aspx">Gesti&oacute;n de programaci&oacute;n</a></li>
			<li><asp:LinkButton ID="lnkLogout" runat="server" OnClick="lnkLogout_Click">Salir</asp:LinkButton></li>					
		</ul>
	</div>
	<div class="searcher">
        <asp:TextBox ID="txtSearch" AutoCompleteType="Search" runat="server"></asp:TextBox>
		<asp:LinkButton ID="lnkSearch" CssClass="btnSearchIcon" runat="server" OnClick="lnkSearch_Click"><div class="searchicon"></div></asp:LinkButton>
	</div>

</div>