﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using TFC.NET.Master;
using TFC.NET.Entities;
using TFC.NET.Business;
using System.Reflection;
using System.IO;

namespace TFC.NET.Control
{
    public partial class TopBar : System.Web.UI.UserControl
    {
        protected string UserName;

        protected void Page_Load(object sender, EventArgs e)
        {
            // By using private.Master public mehods, we don't need to create a utilities class for website
            Private privateFunctions = new Private();
            
            try
            {
                User user = null;
                if (privateFunctions.isLoggedSession(ref user))
                {
                    UserName = user.Name;

                    txtSearch.Attributes.Add("onkeydown", @"if(event.which || event.keyCode){if ((event.which == 13) || (event.keyCode == 13)) {
                            __doPostBack('" + lnkSearch.UniqueID + "','');return false;}} else {return true}; ");
                }

            }
            catch (WrongDataException ex)
            {
                Utilities.LogException("AjaxHandler.ashx",
                           MethodInfo.GetCurrentMethod().Name, ex);
            }
            catch (Exception ex)
            {
                //Script register to show exception info
                ScriptManager.RegisterStartupScript(this, this.GetType(), "showMsg", @"jsError('Lo sentimos pero ha ocurrido un error inexperado');", true);
                Utilities.LogException(Path.GetFileName(Request.Path),
                            MethodInfo.GetCurrentMethod().Name,
                            ex);
            }
        }

        /// <summary>
        /// Event handler for search icon
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void lnkSearch_Click(object sender, EventArgs e)
        {

            Private privateFunctions = new Private();
            User user = null;
            List<UserLink> userList = new List<UserLink>();
            try
            {
                if (privateFunctions.isLoggedSession(ref user))
                {
                    if (GlobalBS.GetUsersLike(txtSearch.Text, ref userList))
                    {
                        UserLink userMatch = userList.Find(delegate(UserLink u)
                        {
                            return u.Name.ToLower().Equals(txtSearch.Text.ToLower());
                        });

                        // If an user has been completely matched, then redirect to profile
                        if (userMatch != null)
                        {
                            Response.Redirect(string.Format("Profile.aspx?user={0}", userMatch.UserIDReq));
                        }
                        else
                        {
                            // Else, redirecto to user matching list
                            Response.Redirect(string.Format("List.aspx?fn=user&search={0}", txtSearch.Text));
                        }
                    }
                }
            }
            catch (WrongDataException ex)
            {
                Utilities.LogException("AjaxHandler.ashx",
                           MethodInfo.GetCurrentMethod().Name, ex);
            }
            catch (Exception ex)
            {
                //Script register to show exception info
                ScriptManager.RegisterStartupScript(this, this.GetType(), "showMsg", @"jsError('Lo sentimos pero ha ocurrido un error inexperado');", true);
                Utilities.LogException(Path.GetFileName(Request.Path),
                            MethodInfo.GetCurrentMethod().Name,
                            ex);
            }
        }

        /// <summary>
        /// Event handler for logout
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void lnkLogout_Click(object sender, EventArgs e)
        {

            Private privateFunctions = new Private();
            try
            {
                User user = null;
                if (privateFunctions.isLoggedSession(ref user))
                {
                    // Remove connection
                    Global.sessionsTable.Remove(user.SessionID);

                    Response.Redirect("Default.aspx");
                    
                }
            }
            catch (WrongDataException ex)
            {
                Utilities.LogException("AjaxHandler.ashx",
                           MethodInfo.GetCurrentMethod().Name, ex);
            }
            catch (Exception ex)
            {
                //Script register to show exception info
                ScriptManager.RegisterStartupScript(this, this.GetType(), "showMsg", @"jsError('Lo sentimos pero ha ocurrido un error inexperado');", true);
                Utilities.LogException(Path.GetFileName(Request.Path),
                            MethodInfo.GetCurrentMethod().Name,
                            ex);
            }

        }


        
    }
}