﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using TFC.NET.Master;
using TFC.NET.Entities;
using System.Reflection;
using System.IO;
using TFC.NET.Business;

namespace TFC.NET.Control
{
    public partial class UserScheduleList : System.Web.UI.UserControl
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            // By using private.Master public mehods, we don't need to create a utilities class for website
            Private privateFunctions = new Private();

            try
            {
                User user = null;
                if (privateFunctions.isLoggedSession(ref user))
                {
                    string eventArgs = Request["__EVENTARGUMENT"];
                    if (!Page.IsPostBack || eventArgs.StartsWith("RefreshSchedule"))
                    {
                        List<Schedule> scheduleList = new List<Schedule>();

                        if (GlobalBS.GetScheduleFromUser(ref user, ref scheduleList))
                        {
                            if (scheduleList.Count > 0)
                            {
                                rptSchedule.DataSource = scheduleList;
                                pnlSchedule.Visible = true;
                            }
                            else
                            {
                                rptSchedule.DataSource = null;
                                pnlSchedule.Visible = false;
                            }
                            rptSchedule.DataBind();
                        }
                    }
                }

            }
            catch (WrongDataException ex)
            {
                Utilities.LogException(Path.GetFileName(Request.Path),
                            MethodInfo.GetCurrentMethod().Name,
                            ex);
            }
            catch (Exception ex)
            {
                //Script register to show exception info
                ScriptManager.RegisterStartupScript(this, this.GetType(), "showMsg", @"jsError('Lo sentimos pero ha ocurrido un error inexperado');", true);
                Utilities.LogException(Path.GetFileName(Request.Path),
                            MethodInfo.GetCurrentMethod().Name,
                            ex);
            }
        }
    }
}