﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.SessionState;
using TFC.NET.Entities;
using TFC.NET.Business;
using System.Collections;
using System.Web.Caching;

namespace TFC.NET
{
    public class Global : System.Web.HttpApplication
    {

        private static Int64 errorCount;
        public static Cache sessionsTable;

        void Application_Start(object sender, EventArgs e)
        {
            errorCount = 0;
            sessionsTable = Context.Cache;
            Utilities.WriteLog("Application starts","log","Application");
        }

        void Application_End(object sender, EventArgs e)
        {
            Utilities.WriteLog(string.Format("Application ends with {0} errors",errorCount), "log", "Application");
        }

        void Application_Error(object sender, EventArgs e)
        {
            Exception ex = Context.Error;
            if (ex is HttpUnhandledException)
            {
                ex = Context.Error.InnerException;
            }

            Entities.Utilities.LogException(Context.Error.Source, "", ex);

        }

        void Session_Start(object sender, EventArgs e)
        {
            // Código que se ejecuta cuando se inicia una nueva sesión

        }

        void Session_End(object sender, EventArgs e)
        {
            // Código que se ejecuta cuando finaliza una sesión.
            // Nota: el evento Session_End se desencadena sólo cuando el modo sessionstate
            // se establece como InProc en el archivo Web.config. Si el modo de sesión se establece como StateServer 
            // o SQLServer, el evento no se genera.

        }

    }
}
