﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using TFC.NET.Entities;

namespace TFC.NET.Master
{
    public partial class PrivateFull : System.Web.UI.MasterPage
    {
        protected void Page_Load(object sender, EventArgs e)
        {

            try
            {
                Private privateFunctions = new Private();
                User user = null;
                if (!privateFunctions.isLoggedSession(ref user))
                {
                    //Script register to restore button functionality and show any issue or message
                    ScriptManager.RegisterStartupScript(this, this.GetType(), "showMsg", @"jsError('Lo sentimos pero su sesión ha caducado');", true);
                }

                hdnuserid.Value = user.UserID.ToString();
                ucmyprofile.ProfileUser = ucmylinks.ProfileUser = user;
                ucmyprofile.isMyProfile = ucmylinks.isMyProfile = true;
            }
            catch (WrongDataException ex)
            {
                //Script register to restore button functionality and show any issue or message
                ScriptManager.RegisterStartupScript(this, this.GetType(), "showMsg", string.Format(@"jsError('{0}');", ex.Message), true);
                return;
            }
            catch (Exception ex)
            {
                //Script register to restore button functionality and show any issue or message
                Utilities.LogException("AjaxHandler.ashx",
                           System.Reflection.MethodInfo.GetCurrentMethod().Name, ex);
                ScriptManager.RegisterStartupScript(this, this.GetType(), "showMsg", @"jsError('Lo sentimos pero ocurrió un error inexperado');", true);
                return;
            }
        }


    }
}