﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using TFC.NET.Entities;
using TFC.NET.Business;
using System.IO;
using System.Reflection;
using TFC.NET.Master;

namespace TFC.NET
{
    public partial class Messages : System.Web.UI.Page
    {

        public User userTo
        {
            get
            {
                Decimal userid;
                // look for current page in ViewState
                object o = this.ViewState["_MessagesWith"];
                if (o == null){
                    if (!string.IsNullOrEmpty(Request["userid"]) && Decimal.TryParse(Request["userid"], out userid))
                    {
                        return new User() { UserID = userid };
                    }
                    else
                    {
                        throw new WrongDataException("No se pudo recuperar el usuario");
                    }
                }else{
                    return (User)o;
                }
            }

            set
            {
                this.ViewState["_MessagesWith"] = value;
            }
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            
            User user = null;
            Decimal userid;

            try{

                if (!string.IsNullOrEmpty(Request["userid"]) && Decimal.TryParse(Request["userid"], out userid))
                {
                    user = new User()
                    {
                        UserID = userid
                    };

                    if (!GlobalBS.GetUser(ref user))
                    {
                        throw new WrongDataException("No se han podido recuperar datos para el usuario solicitado");
                    }

                    lblUsername.Text = string.Format("Mensajes con {0}",user.Name);

                    ucbubbleslist.ProfileUser = user;
                    ucbubbleslist.isMessages = true;

                }
                else
                {
                    throw new WrongDataException("No se han podido recuperar datos para el usuario solicitado");
                }
            }
            catch (WrongDataException ex)
            {
                //Script register to show exception info
                ScriptManager.RegisterStartupScript(this, this.GetType(), "showMsg", string.Format(@"jsAlert('{0}');", ex.Message), true);
                responseTxt.Text = ex.Message;
                return;
            }
            catch (Exception ex)
            {
                //Script register to show exception info
                ScriptManager.RegisterStartupScript(this, this.GetType(), "showMsg", @"jsError('Lo sentimos pero ha ocurrido un error inexperado');", true);

                responseTxt.Text = "Lo sentimos pero ha ocurrido un error inexperado";

                Utilities.LogException(Path.GetFileName(Request.Path),
                            MethodInfo.GetCurrentMethod().Name,
                            ex);
                return;
            }
        }

        /// <summary>
        /// Event handler for publication button
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void btnPublication_Click(object sender, EventArgs e)
        {

            Private privateFunctions = new Private();
            User user = new User();
            try
            {
                MaintainScrollPositionOnPostBack = true;
                privateFunctions.isLoggedSession(ref user);

                string msg = Utilities.StripHtml(txtpublication.Text, true);
                if (!string.IsNullOrEmpty(msg))
                {

                    if (GlobalBS.InsertNewMessage(user, userTo, msg))
                    {
                        txtpublication.Text = string.Empty;
                        ScriptManager.RegisterStartupScript(this, this.GetType(), "showMsg", @"__doPostBack('udpBubblePanel','');", true);
                    }
                }
                else
                {
                    responseTxt.Text = "Por favor, introduzca un texto para su publicación";
                }
            }
            catch (WrongDataException ex)
            {
                //Script register to show exception info
                ScriptManager.RegisterStartupScript(this, this.GetType(), "showMsg", string.Format(@"jsAlert('{0}');", ex.Message), true);
                responseTxt.Text = ex.Message;
                return;
            }
            catch (Exception ex)
            {
                //Script register to show exception info
                ScriptManager.RegisterStartupScript(this, this.GetType(), "showMsg", @"jsError('Lo sentimos pero ha ocurrido un error inexperado');", true);

                responseTxt.Text = "Lo sentimos pero ha ocurrido un error inexperado";

                Utilities.LogException(Path.GetFileName(Request.Path),
                            MethodInfo.GetCurrentMethod().Name,
                            ex);
                return;
            }
        }
    }
}