﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using TFC.NET.Master;
using TFC.NET.Entities;
using TFC.NET.Business;
using System.IO;
using System.Reflection;

namespace TFC.NET
{
    public partial class Profile : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            Decimal userid = 0;

            if (!string.IsNullOrEmpty(Request["user"]) && Decimal.TryParse(Request["user"], out userid))
            {
                try
                {

                    User user = new User()
                    {
                        UserID = userid
                    };

                    // Get user information
                    if (!GlobalBS.GetUser(ref user))
                    {
                        throw new WrongDataException("Lo sentimos pero ocurrió un error al recuperar el usuario");
                    }

                    ucbubbleslist.ProfileUser = ucuserlinks.ProfileUser = ucuserprofile.ProfileUser = user;
                    ucbubbleslist.isMyProfile = ucuserlinks.isMyProfile = ucuserprofile.isMyProfile = false;
                    ucptools.UserTo = userid;

                }
                catch (WrongDataException ex)
                {
                    //Script register to show exception info
                    ScriptManager.RegisterStartupScript(this, this.GetType(), "showMsg", string.Format(@"jsError('{0}');", ex.Message), true);
                    return;
                }
                catch (Exception ex)
                {
                    //Script register to show exception info
                    ScriptManager.RegisterStartupScript(this, this.GetType(), "showMsg", @"jsError('Lo sentimos pero ha ocurrido un error inexperado');", true);
                    Utilities.LogException(Path.GetFileName(Request.Path),
                                MethodInfo.GetCurrentMethod().Name,
                                ex);
                    return;
                }
            }
        }
    }
}